/*
 * File         : Jacobi.C
 * Author       : Guansong Zhang
 * Created      : Tue Feb  3 13:35:51 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */


#include "math.h"
#include "adlib.h"

const int n = 1024;
float a [n][n], b [n][n];

int main(int argc, char** argv) {

  int i, j ;

  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      if (i==0 || i==n-1 || j==0 || j==n-1)
	a[i][j]=1;
      else
	a[i][j]=0;
    }
  }

  for (int iter=0; iter<100; iter++) {

    if (iter==10)
      AdlibClock(0);

    /* for poor solaris 2.5.1
    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {      
	
	b[i][j]=a[i][j];
      }
    }
    */

    for (i=1; i<n-1; i++) {
      for (j=1; j<n-1; j++) {

	b[i][j]=a[i][j];
      }
    }

    for (i=1; i<n-1; i++) {
      for (j=1; j<n-1; j++) {    

	a[i][j]=((b[i-1][j]+b[i+1][j]+b[i][j-1]+b[i][j+1])*0.25);
      }
    }
  }

  AdlibClock(1);
}

